import { get, create, remove, update } from 'pubsweet-client/src/helpers/api'

const SET_HANDLING_EDITORS = 'SET_HANDLING_EDITORS'

const setHandlingEditors = editors => ({
  type: SET_HANDLING_EDITORS,
  editors,
})

export const handlingEditors = state => state.editors

export const getHandlingEditors = () => dispatch =>
  get(`/users?handlingEditor=true`).then(res => {
    dispatch(setHandlingEditors(res.users))
  })

export const assignHandlingEditor = (email, collectionId) => dispatch =>
  create(`/collections/${collectionId}/invitations`, {
    email,
    role: 'handlingEditor',
  })

export const revokeHandlingEditor = (invitationId, collectionId) => dispatch =>
  remove(`/collections/${collectionId}/invitations/${invitationId}`)

export const handlingEditorDecision = (
  invitationId,
  collectionId,
  isAccepted,
  reason,
) =>
  update(`/collections/${collectionId}/invitations/${invitationId}`, {
    isAccepted,
    reason,
  })

const initialState = []
export default (state = initialState, action = {}) => {
  switch (action.type) {
    case SET_HANDLING_EDITORS:
      return action.editors
    default:
      return state
  }
}
